using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using TIS.Imaging;

namespace Grabbing_an_Image
{
    public partial class Form1 : Form
    {
        private long count;
        

        public Form1()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Form1_Load
        ///
        /// If no device has been selected in the properties window of IC Imaging
        /// Control, the device settings dialog of IC Imaging Control is show at
        /// start of this sample. 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Form1_Load(object sender, EventArgs e)
        {
            count = 0;

            if ( !icImagingControl1.LoadShowSaveDeviceState("lastSelectedDeviceState.xml") )
            {
                MessageBox.Show("No device was selected.", "Reconnect Camera", MessageBoxButtons.OK, MessageBoxIcon.Information);
                this.Close();
            }
            else
            {

                icImagingControl1.SaveDeviceStateToFile("device.xml");
            }

            cmdStartLive.Enabled = true;
            cmdStopLive.Enabled = false;
            cmdSaveBitmap.Enabled = false;
            label1.Text = "";
            label2.Text = "DirectShow/ICImagingControlɈnÕhCoɑoꂽt[ ";
            label3.Text = "AvP[VŃhbvt[";
            label4.Text =  "f[^]rɃhbvt[";
            label5.Text = "hCoŃhbvt[";
            label6.Text = "łȂhbvt[";
            label7.Text = "";
@          label8.Text = "";
            label9.Text = "";
            label10.Text = "";
            label11.Text = "";
        }

        /// <summary>
        /// cmdStartLive_Click
        ///
        /// Start the live video. A valid video capture device should have been
        /// selected previsously in the properties window of IC Imaging Control.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
		//<<startlive
        private void cmdStartLive_Click(object sender, EventArgs e)
        {
            icImagingControl1.Sink = new TIS.Imaging.FrameSnapSink();

            icImagingControl1.LiveStart();

            cmdStartLive.Enabled = false;
            cmdStopLive.Enabled = true;
            cmdSaveBitmap.Enabled = true;
        }
        //>>
        /// <summary>
        /// cmdStopLive_Click
        ///
        /// Stop the live video.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        //<<stoplive
        private void cmdStopLive_Click(object sender, EventArgs e)
        {
            icImagingControl1.LiveStop();

            cmdStartLive.Enabled = true;
            cmdStopLive.Enabled = false;
            cmdSaveBitmap.Enabled = false;
        }
        //>>

        /// <summary>
        /// cmdSaveBitmap_Click
        ///
        /// Snap an image from the live video stream and show the file save
        /// dialog. After a file name has been selected, the image is saved.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        //<<savebitmap
        private void cmdSaveBitmap_Click( object sender, EventArgs e )
        {
            TIS.Imaging.FrameSnapSink snapSink = icImagingControl1.Sink as TIS.Imaging.FrameSnapSink;

            TIS.Imaging.IFrameQueueBuffer frm = snapSink.SnapSingle(TimeSpan.FromSeconds(5));
            
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();
            saveFileDialog1.Filter = "bmp files (*.bmp)|*.bmp|All files (*.*)|*.*";
            saveFileDialog1.FilterIndex = 1;
            saveFileDialog1.RestoreDirectory = true;

            if( saveFileDialog1.ShowDialog() == DialogResult.OK )
            {
                frm.SaveAsBitmap(saveFileDialog1.FileName);
            }
        }

        private void IcImagingControl1_DeviceLost(object sender, ICImagingControl.DeviceLostEventArgs e)
        {
            icImagingControl1.Device = "";
        }

        private void IcImagingControl1_DeviceListChanged(object sender, EventArgs e)
        {
            try
            {
                // foCX쒆łΒ~܂B
                if (icImagingControl1.LiveVideoRunning)
                    icImagingControl1.LiveStop();


                // RtBM[Vt@C Load ܂B
                icImagingControl1.LoadDeviceStateFromFile("device.xml", true);

                // CurfIĊJ܂B
                if (icImagingControl1.DeviceValid)
                    icImagingControl1.LiveStart();

                count++;

                label1.Text = "foCXXgF@" + count + "";
            }
            catch 
            {
                label1.Text = "foCXXg";
            }
        }


        private void Timer1_Tick(object sender, EventArgs e)
        {
            if (icImagingControl1.DeviceValid)
            { 
                //DirectShow/ICImagingControlɈnÕhCoɑoꂽt[
                ulong _framesDelivered = icImagingControl1.DriverFrameDropInformation.FramesDelivered;
                //AvP[VŃhbvt[BR[obNɃhCoAvP[Ṽobt@ւ̃Rs[Ɏ Ԃ鎖ȗvłB
                ulong _framesDroppedDueToApplicationQueue = icImagingControl1.DriverFrameDropInformation.FramesDroppedDueToApplicationQueue;
                //f[^]rɃhbvt[BMf[^sSłAf[^ш敝\łȂƂƂ čl܂B
                ulong _framesDroppedDueToPacketLoss = icImagingControl1.DriverFrameDropInformation.FramesDroppedDueToPacketLoss;
                //hCoŃhbvt[B擾tH[}bgo͂tH[}bgɉ摜ϊ̂ԂɂĂȂ Ƃl炦܂B
                ulong _framesDroppedDueToTransforms = icImagingControl1.DriverFrameDropInformation.FramesDroppedDueToTransforms;
                //łȂhbvt[BhCot[hbv񋟂ĂȂl܂B
                ulong _framesDroppedDueUnspecified = icImagingControl1.DriverFrameDropInformation.FramesDroppedDueUnspecified;

                label7.Text = _framesDelivered.ToString() + "";
                label8.Text = _framesDroppedDueToApplicationQueue.ToString() + "";
                label9.Text = _framesDroppedDueToPacketLoss.ToString() + "";
                label10.Text = _framesDroppedDueToTransforms.ToString() + "";
                label11.Text = _framesDroppedDueUnspecified.ToString() + "";
            }

        }
        //>>
    }
}